
public class Speed7 {

  public static void main(String[] args) {
    System.out.println("Entering main().");
    try {                                                        //(1)
//    printSpeed(100, 20);                                       //(2a)
      printSpeed(-100,20);                                       //(2b)
    }
    catch (SpeedCalculationException exception) {                //(3)
      System.out.println(exception + " (handled in main())");
    }
    finally {                                                    //(4)
      System.out.println("Command to use: java Speed7");
    }
    System.out.println("Returning from main().");
  }

  private static void printSpeed(int kilometers, int hours)
                      throws SpeedCalculationException {         //(5)
    System.out.println("Entering printSpeed().");
    double speed = calculateSpeed(kilometers, hours);
    System.out.println("Speed = " +
        kilometers + "/" + hours + " = " + speed);
    System.out.println("Returning from printSpeed().");
  }

  private static int calculateSpeed(int distance, int time)
                     throws SpeedCalculationException {          //(6)
    System.out.println("Calculating speed.");
    if (distance < 0 || time <= 0)
      throw new SpeedCalculationException("distance and time " +
                                          "must be > 0");        //(7)
    return distance/time;
  }
}